package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10055PassWordReault;
import cn.net.cpzslibs.prot.handset.bean.Prot10055SendBeanPassWord;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10055ChangePassWord extends ProtBase {
	
	
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10055 = 10055;
	
	private Gson gson;
	
	private Prot10055PassWordReault res;
	
	
	
	
	public Prot10055PassWordReault getRes() {
		return res;
	}


	public void setRes(Prot10055PassWordReault res) {
		this.res = res;
	}


	public Prot10055ChangePassWord() {
		gson = new Gson();
	}
	
	
	public void dealChangePassWord(SocketCreate create, Prot10055SendBeanPassWord passWordBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), passWordBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10055SendBeanPassWord loginBean)
			throws IOException {
		if (socket.isConnected()) {
			
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10055, "开始发送登录信息");
				sendProt(dos, loginBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recPassWord(dis);
			}
		}	
	}	
	

	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recPassWord(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10055, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10055, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10055PassWordReault.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10055SendBeanPassWord passWordBean) throws IOException {
		String bodyContent = gson.toJson(passWordBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10055, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	
	
}
